<?php

namespace EventPortal\Domain\Util;

use EventPortal\Domain\Component\Input;
use EventPortal\Domain\Component\Section;

class ValidationRules
{
    public static function for(array $fields): array
    {
        return collect($fields)
            ->map(function ($field) {
                if ($field instanceof Section === false) {
                    return $field;
                }

                return $field->children;
            })
            ->flatten(1)
            ->mapWithKeys(function (Input $input) {
                return [
                    $input->name => $input->validation,
                ];
            })
            ->filter()
            ->toArray();
    }
}
